/*
 * TCSS 305Winter 2014
 * Assignment 5b-PowerPaint
 */

package drawingpanelandtools;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Shape;
import java.awt.geom.GeneralPath;
import java.awt.geom.Line2D;
import java.awt.geom.RectangularShape;

/**
 * This class allows a PaintShape to be created that holds a certain shape, color, and 
 * pixel width.
 * 
 * @author Brian Dennis
 * @version 20 February 2014
 */
public class PaintShape {

    /** The kind of shape it is. */
    private Shape myShape;
    
    /** How wide the objects brush stroke is. */
    private final BasicStroke myShapeWidth;
    
    /** The color of the shape. */
    private final Color myColor;
    
    /**
     * This constructor initializes the variables, as well as clones the shape parameter  
     * depending on what kind of shape it is.
     * 
     * @param theShape the shape of the object
     * @param theShapeWidth the shapes's width
     * @param theColor the color of the shape
     */
    public PaintShape(final Shape theShape, final int theShapeWidth, final Color theColor) {
        
        myShapeWidth = new BasicStroke(theShapeWidth);
        myColor = theColor;
        
        if (theShape instanceof Line2D) {
            
            myShape = (Shape) ((Line2D) theShape).clone();
            
        } else if (theShape instanceof RectangularShape) {
            
            myShape = (Shape) ((RectangularShape) theShape).clone();
            
        } else if (theShape instanceof GeneralPath) {
            
            myShape = (Shape) ((GeneralPath) theShape).clone();
        }
    }

    /**
     * This method returns the shape of the object.
     * 
     * @return the shape of this object.
     */
    public Shape getShape() {
        
        return myShape;
    }
    
    /**
     * This method returns an integer that represents the width of the shape.
     * 
     * @return the width of the shape
     */
    public BasicStroke getShapeWidth() {
        
        return myShapeWidth;
    }
    
    /**
     * This methods returns the color of the shape.
     * 
     * @return the color of the shape
     */
    public Color getColor() {
        
        return myColor;
    }
}