/*
 * TCSS 305Winter 2014
 * Assignment 5b-PowerPaint
 */

package drawingpanelandtools;

import java.awt.event.MouseEvent;

/**
 * This interface declares the methods that are require, in order to be considered a tool in 
 * this program.
 * 
 * @author Brian Dennis
 * @version 20 February 2014
 */
public interface ToolInterface {
       
    /** 
     * Describes tool behaviors when mouse is pressed. 
     * 
     * @param theEvent the event for when the mouse is pressed
     */
    void ifPressed(MouseEvent theEvent);
        
    /** 
     * Describes tool behaviors when mouse is dragged. 
     * 
     * @param theEvent the event for when the mouse is dragged
     */
    void whileDragged(MouseEvent theEvent);
        
    /** 
     * Describes tool behaviors when mouse is released. 
     * 
     * @param theEvent the event for when the mouse is released
     */
    void ifReleased(MouseEvent theEvent);
        
    /** 
     * returns segments of a shape used to create a growing shape while dragged. 
     * 
     * @return a PaintShape segment
     */ 
    PaintShape returnDraggedShape();
        
    /** 
     * returns a shape used to create a final shape. 
     * 
     * @return a final PaintShape
     */
    PaintShape returnReleasedShape();
}