/*
 * TCSS 305Winter 2014
 * Assignment 5b-PowerPaint
 */

package gui.actions;
import drawingpanelandtools.DrawingPanel;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JColorChooser;

/**
 * This class constructs an action for the Color tool JButton.
 * 
 * @author Bad Man Dennis
 * @version 20 February 2014
 */
@SuppressWarnings("serial")
public class ColorAction extends AbstractAction {
    
    /** The drawing board panel of the GUI. */
    private final DrawingPanel myCanvas;
    
    /**
     * Construct this Action, setting mnemonics, the title of the button, and the initial 
     * state of it's icon.
     * 
     * @param theCanvas a JPanel to associate with this Action.
     */
    public ColorAction(final DrawingPanel theCanvas) {
        
        super("Color...", new ColorChoosed(Color.BLACK));
        myCanvas = theCanvas;
        putValue(Action.MNEMONIC_KEY, KeyEvent.VK_C);
    }
    
    /**
     * This method allows a ColorChooser dialog box to appear when the user clicks on the 
     * color JButton. It then sets the "brush" to the color the user wants, and sets the 
     * color's icon to the current color.
     * 
     * @param theEvent the event that occurs that initiates the action.
     */
    @Override
    public void actionPerformed(final ActionEvent theEvent) {
     
        Color newColor = null;
        newColor = JColorChooser.showDialog(myCanvas, "Color Chooser", null);
        
        if (newColor != null) {
            
            myCanvas.setBrushColor(newColor);
            putValue(Action.SMALL_ICON, new ColorChoosed(newColor));
        }
    }
}