/*
 * TCSS 305Winter 2014
 * Assignment 5b-PowerPaint
 */

package gui.actions;
import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import javax.swing.Icon;

/**
 * This class constructs an icon that represents 12x12 square that holds a color. It is used 
 * to represent the current color choice.
 * 
 * @author Bad Man Dennis
 * @version 20 February 2014
 */
public class ColorChoosed implements Icon {
   
    /** a number representing the width and height of the square. */
    private static final int SQUARE_WIDTH_AND_HEIGHT = 12;
    
    /** The color the user chooses. */
    private final Color myColor;
    
    /**
     * This constructor sets the color to the current choice.
     * 
     * @param theColor the color the user chooses.
     */
    public ColorChoosed(final Color theColor) {
        
        myColor = theColor;
    }

    /*
     * Creates the icon for the color button
     * 
     * @see javax.swing.Icon#paintIcon(java.awt.Component, java.awt.Graphics, int, int)
     */
    @Override
    public void paintIcon(final Component theComponent, 
                          final Graphics theGraphics, 
                          final int theX, 
                          final int theY) {
        
        final Color oldColor = theGraphics.getColor();
        theGraphics.setColor(myColor);
        theGraphics.fill3DRect(theX, theY, getIconWidth(), getIconHeight(), true);
        theGraphics.setColor(oldColor);
    }

    /**
     * @return the icon width.
     */
    @Override
    public int getIconWidth() {
        
        return SQUARE_WIDTH_AND_HEIGHT;
    }

    /**
     * @return 12 the icon height.
     */
    @Override
    public int getIconHeight() {
        
        return SQUARE_WIDTH_AND_HEIGHT;
    }        
}