/*
 * TCSS 305Winter 2014
 * Assignment 5b-PowerPaint
 */

package gui.actions;
import drawingpanelandtools.DrawingPanel;
import drawingpanelandtools.EllipseTool;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import javax.swing.AbstractAction;
import javax.swing.Action;

/**
 * This class constructs an action for the Ellipse tool JRadioButton.
 * 
 * @author Bad Man Dennis
 * @version 20 February 2014
 */
@SuppressWarnings("serial")
public class EllipseAction extends AbstractAction {

    /** The drawing board panel of the GUI. */
    private final DrawingPanel myCanvas;
    
    /**
     * Construct this Action, setting mnemonics and the title of the button.
     * 
     * @param theCanvas a JPanel to associate with this Action.
     */
    public EllipseAction(final DrawingPanel theCanvas) {
        
        super("Ellipse");
        myCanvas = theCanvas;
        putValue(Action.MNEMONIC_KEY, KeyEvent.VK_E);
        putValue(Action.SELECTED_KEY, false);
    }
    
    /**
     * This method creates an Ellipse tool to use, and passes it to the DrawingPanel object 
     * when the Ellipse tool button is selected.
     * 
     * @param theEvent the event that occurs that initiates the action.
     */
    @Override
    public void actionPerformed(final ActionEvent theEvent) {
        
        myCanvas.setCurrentTool(new EllipseTool(myCanvas));
    }
}