/*
 * TCSS 305Winter 2014
 * Assignment 5b-PowerPaint
 */

package gui.actions;
import drawingpanelandtools.DrawingPanel;
import drawingpanelandtools.RectangleTool;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import javax.swing.AbstractAction;
import javax.swing.Action;

/**
 * This class constructs an action for the Rectangle tool JRadioButton.
 * 
 * @author Bad Man Dennis
 * @version 20 February 2014
 */
@SuppressWarnings("serial")
public class RectangleAction extends AbstractAction {

    /** The drawing board panel of the GUI. */
    private final DrawingPanel myCanvas;
    
    /**
     * Construct this Action, setting mnemonics and the title of the button.
     * 
     * @param theCanvas a JPanel to associate with this Action.
     */
    public RectangleAction(final DrawingPanel theCanvas) {
        
        super("Rectangle");
        myCanvas = theCanvas;
        putValue(Action.MNEMONIC_KEY, KeyEvent.VK_R);
        putValue(Action.SELECTED_KEY, false);
    }
    
    /**
     * This method creates a Rectangle tool to use, and passes it to the DrawingPanel object 
     * when the Rectangle tool button is selected.
     * 
     * @param theEvent the event that occurs that initiates the action.
     */
    @Override
    public void actionPerformed(final ActionEvent theEvent) {
     
        myCanvas.setCurrentTool(new RectangleTool(myCanvas));
    }
}