/*
 * TCSS 305Winter 2014
 * Assignment 5b-PowerPaint
 */

package gui.bars;

import drawingpanelandtools.DrawingPanel;
import gui.menus.FileMenu;
import gui.menus.HelpMenu;
import gui.menus.OptionsMenu;
import gui.menus.ToolsMenu;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JRadioButton;

/**
 * This class constructs the JMenuBar found on the North section of the GUI.
 * 
 * @author Bad Man Dennis
 * @version 20 February 2014
 */
@SuppressWarnings("serial")
public class MenuBar extends JMenuBar {
    
    /** the JMenu representing the File menu. */
    private final FileMenu myFileMenu;
    
    /** the JMenu representing the Options menu. */
    private final OptionsMenu myOptionsMenu;
    
    /** the JMenu representing the Tools menu. */
    private final JMenu myToolsMenu;
    
    /** the JMenu representing the Help menu. */
    private final JMenu myHelpMenu;
    
    /**
     * The constructor creates JMenu objects passing int the parameters and adds them to this 
     * JMenuBar by calling makeMenuItems().
     * 
     * @param theFrame the frame of the GUI
     * @param theCanvas the drawing canvas of the JFrame
     * @param theColorB JButton with an action in it
     * @param thePencilB JRadioButton with an action in it
     * @param theLineB JRadioButton with an action in it
     * @param theRectangleB JRadioButton with an action in it
     * @param theEllipseB JRadioButton with an action in it
     */
    public MenuBar(final JFrame theFrame,
                   final DrawingPanel theCanvas, 
                   final JButton theColorB, 
                   final JRadioButton thePencilB, 
                   final JRadioButton theLineB, 
                   final JRadioButton theRectangleB, 
                   final JRadioButton theEllipseB) {
        
        super();
        
        myFileMenu = new FileMenu("File", theCanvas, theFrame);
        myOptionsMenu = new OptionsMenu("Options", theCanvas);
        myToolsMenu = new ToolsMenu("Tools", theColorB, thePencilB, theLineB, theRectangleB, 
                                                                                 theEllipseB);
        myHelpMenu = new HelpMenu("Help", theCanvas);

        makeMenuItems();
    }
    
    /**
     * This method adds all the various buttons onto the MenuBar.
     */
    private void makeMenuItems() {

        add(myFileMenu);
        add(myOptionsMenu);
        add(myToolsMenu);
        add(myHelpMenu);
    }
}