/*
 * TCSS 305Winter 2014
 * Assignment 5b-PowerPaint
 */

package gui.menus;
import drawingpanelandtools.DrawingPanel;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;

/**
 * This class constructs the Help JMenu found on the North JMenuBar of the GUI. It also 
 * creates an ActionListener for this JMenu.
 * 
 * @author Brian Dennis
 * @version 20 February 2014
 */
@SuppressWarnings("serial")
public class HelpMenu extends JMenu {

    /** A reference to the panel that the user draws on. */
    private final DrawingPanel myCanvas;
    
    /** A String used for the "Option..." JMenuItem titles and Action commands. */
    private final String myAboutString;
    
    /**
     * The constructor initializes variables to a reasonable state and sets a mnemonic for 
     * this JMenu Object. It also makes a method call to makeMenuItems().
     * 
     * @param theMenuName the name of the JMenu
     * @param theCanvas the JPanel you draw on
     */
    public HelpMenu(final String theMenuName, final DrawingPanel theCanvas) {
        
        super();
        this.setText(theMenuName);
        this.setMnemonic(KeyEvent.VK_H);
        myCanvas = theCanvas;
        myAboutString = "About...";
        
        makeMenuItems();
    }

    /**
     * This method creates the 2 JMenuItems found inside the File JMenu, adding Listeners and 
     * mnemonics to them.
     */
    private void makeMenuItems() {
        
        final JMenuItem about = new JMenuItem(myAboutString);
        about.setMnemonic(KeyEvent.VK_A);
        about.addActionListener(new Listener());
        about.setActionCommand(myAboutString);
       
        add(about);
    }
    
    /**
     * This method Allows The HelpMenu to create an Action Listener for it's JMenuItem.
     * 
     * @author Bad Man Dennis
     * @version 20 February 2014
     */
    class Listener implements ActionListener {
        
        /**
         * This method manages what happens when the related JMenuItems are used.
         * 
         * @param theAction the action being analyzed
         */
        public void actionPerformed(final ActionEvent theAction) {
                    
            final String action = theAction.getActionCommand();
            
            if (myAboutString.equals(action)) {
 
                JOptionPane.showMessageDialog(myCanvas, "TCSS 305 PowerPaint, Winter 2014");
            }
        }
    }
}