/*
 * TCSS 305Winter 2014
 * Assignment 5b-PowerPaint
 */

package gui.menus;
import drawingpanelandtools.DrawingPanel;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import javax.swing.JButton;

/**
 * This class makes a redo button and adds all of it's components.
 * @author Bad Man Dennis
 * @version 20 February 2014
 */
@SuppressWarnings("serial")
public class RedoButton extends JButton {

    /** A string to use whenever the word redo is needed. */
    private static final String REDO = "Redo";
    
    /** the JPanal that the user draws on. */
    private final DrawingPanel myCanvas;

    /**
     * This constructor initializes variables of redo button.
     * @param theCanvas the drawing board
     */
    public RedoButton(final DrawingPanel theCanvas) {
        
        super(REDO);
        
        myCanvas = theCanvas;
        setMnemonic(KeyEvent.VK_R);
        addActionListener(new Listener());
        setActionCommand(REDO);
        setEnabled(false);
    }
    
    /**
     * This method Allows The RedoButton to create an Action Listener for itself.
     * 
     * @author Brian Dennis
     * @version 20 February 2014
     */
    class Listener implements ActionListener {
        
        /**
         * This method manages what happens when the Redo button is used.
         * 
         * @param theAction the action being analyzed
         */
        @Override
        public void actionPerformed(final ActionEvent theAction) {
                    
            final String action = theAction.getActionCommand();
            
            if (REDO.equals(action)) {
                
                myCanvas.redoDrawnShape();
                myCanvas.repaint();   
            } 
        }
    }
}