/*
 * TCSS 305Winter 2014
 * Assignment 5b-PowerPaint
 */

package gui.menus;

import java.awt.event.KeyEvent;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JMenu;
import javax.swing.JRadioButton;


/**
 * This class constructs the Tools JMenu found on the North JMenuBar of the GUI.
 * 
 * @author Brian Dennis
 * @version 20 February 2014
 */
@SuppressWarnings("serial")
public class ToolsMenu extends JMenu {

    /** This button already has an action connected to it, and represents the color button.*/
    private final JButton myColorButton;
    
    /** This button already has an action connected to it, and represents the pencil button.*/
    private final JRadioButton myPencilButton;
    
    /** This button already has an action connected to it, and represents the line button.*/
    private final JRadioButton myLineButton;
    
    /** This button already has an action connected to it, and represents 
                                                                       the rectangle button.*/
    private final JRadioButton myRectangleButton;
    
    /**This button already has an action connected to it, and represents the ellipse button.*/
    private final JRadioButton myEllipseButton;
    
    /** This group is used to group the various tool buttons. */
    private final ButtonGroup myGroup;
    
    /**
     * This Constructor sets the buttons and the group to reasonable initial values. It also 
     * sets a mnemonic for tools.
     * 
     * @param theMenuName the name of the tools menu
     * @param theColorB the color button tool
     * @param thePencilB the pencil radioButton tool
     * @param theLineB the line radioButton tool
     * @param theRectangleB the rectangle radioButton tool
     * @param theEllipseB the ellipse radioButton tool
     */
    public ToolsMenu(final String theMenuName, 
                     final JButton theColorB, 
                     final JRadioButton thePencilB, 
                     final JRadioButton theLineB, 
                     final JRadioButton theRectangleB, 
                     final JRadioButton theEllipseB) {
        
        super();
        this.setText(theMenuName);
        this.setMnemonic(KeyEvent.VK_T);
        
        myColorButton = theColorB;
        myPencilButton = thePencilB;
        myLineButton = theLineB;
        myRectangleButton = theRectangleB;
        myEllipseButton = theEllipseB;
        
        myGroup = new ButtonGroup();
        
        makeMenuItems();
    }
    
    /**
     * This method adds the buttons to this JMenu and then adds the four tools to an 
     * associated group.
     */
    private void makeMenuItems() {
     
        myGroup.add(myLineButton);
        myGroup.add(myPencilButton);
        myGroup.add(myRectangleButton);
        myGroup.add(myEllipseButton);
        
        add(myColorButton);
        add(myPencilButton);
        add(myLineButton);
        add(myRectangleButton);
        add(myEllipseButton);
    }
}