/*
 * TCSS 305Winter 2014
 * Assignment 5b-PowerPaint
 */

package gui.menus;
import drawingpanelandtools.DrawingPanel;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import javax.swing.JButton;

/**
 * This class makes a undo button and adds all of it's components.
 * @author Bad Man Dennis
 * @version 20 February 2014
 */
@SuppressWarnings("serial")
public class UndoButton extends JButton {

    /** A string to use whenever the word undo is needed. */
    private static final String UNDO = "Undo";
    
    /** the JPanal that the user draws on. */
    private final DrawingPanel myCanvas;
    
    /**
     * This constructor initializes variables of undo button.
     * @param theCanvas the drawing board
     */
    public UndoButton(final DrawingPanel theCanvas) {
        
        super(UNDO);
        
        myCanvas = theCanvas;
        setMnemonic(KeyEvent.VK_U);
        addActionListener(new Listener());
        setActionCommand(UNDO);
        setEnabled(false);
    }
    
    /**
     * This method Allows The UndoButton to create an Action Listener for itself.
     * 
     * @author Brian Dennis
     * @version 20 February 2014
     */
    class Listener implements ActionListener {
        
        /**
         * This method manages what happens when the Undo button is used.
         * 
         * @param theAction the action being analyzed
         */
        @Override
        public void actionPerformed(final ActionEvent theAction) {
                    
            final String action = theAction.getActionCommand();
            
            if (UNDO.equals(action)) {
                
                myCanvas.undoDrawnShape();
                myCanvas.repaint();   
            } 
        }
    }
}