/*
 * TCSS 305Winter 2014
 * Assignment 5b-PowerPaint
 */

package main;

import gui.PowerPaintGUI;
import java.awt.EventQueue;

/**
 * This is the main method class that creates the PowerPaintGUI and then runs it by making a 
 * call to gui.start().
 * 
 * @author Brian Dennis
 * @version 20 February 2014
 */
public final class PowerPaintMain {

    /**
     * Private constructor, to prevent instantiation of this class.
     */
    private PowerPaintMain() {
        
        throw new IllegalStateException();
    }
    
    /**
     * The main method, invokes the PowerPaint GUI.
     * 
     * @param theArgs Command line arguments.
     */
    public static void main(final String[] theArgs) {
        EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                final PowerPaintGUI gui = new PowerPaintGUI();
                gui.start();    
            }
        });
    }
}